# This is MakeWeb, Version 3.0
# Copyright (C) 1996,1997,1998,1999,2000 by Hiroshi Yuki <hyuki@hyuki.com>
# http://www.hyuki.com/makeweb/
# All rights reserved.
#
$rcs = '$Id: makeweb.pl 1.4 2000/01/14 09:42:40 yuki Exp yuki $';
$debug = 0;
%config = (
    'include_filename', 0,      # MakeWeb̓̓t@Co̓t@C̃RgɊ܂߂Ȃ 1
);
#
$usage = <<"EOD";
This is MakeWeb, Version 3.0
Copyright (C) 1996,1997,1998,1999 by Hiroshi Yuki <hyuki\@st.rim.or.jp>.
http://www.st.rim.or.jp/~hyuki/makeweb/
All rights reserved.

$rcs

Usage 1: perl makeweb.pl -html input.txt > output.html
Usage 2: perl makeweb.pl -latex input.txt > output.tex
EOD

# Predefined commands
sub init_defs {
    &do_define('title', '');
    &do_define('subtitle', '');
    &do_define('author', '');
    &do_define('autoinsert', '');   # s玩Iɑ}^O
    &do_define('usenumber', '0');   # ZNVԍȂ 1
    &do_define('usetilde', '0');    # N̒ ~  %7E ɕϊȂ 1
    &do_define('itemline', '<HR>'); # "*" ɂ؂(HTML only)
    &do_define('subitemline', '');  # "-*" ɂ؂(HTML only)
}

# Color scheme names.
%colortag = (
    'none',     '',
    'white',    'TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#FF0000" VLINK="#800080" ALINK="#0000FF"',
    'offwhite', 'TEXT="#000000" BGCOLOR="#FFF0F0" LINK="#FF0000" VLINK="#800080" ALINK="#0000FF"',
    'yellow',   'TEXT="#400040" BGCOLOR="#FFFF80" LINK="#0000FF" VLINK="#008000" ALINK="#FF0080"',
    'ltyellow', 'TEXT="#000000" BGCOLOR="#FFFFC0" LINK="#0000FF" VLINK="#800080" ALINK="#FF00FF"',
    'ltblue',   'TEXT="#000000" BGCOLOR="#C0C0FF" LINK="#0000FF" VLINK="#800080" ALINK="#FF0080"',
    'midblue',  'TEXT="#000000" BGCOLOR="#8080C0" LINK="#FFFFFF" VLINK="#800080" ALINK="#FFFF00"',
    'orange',   'TEXT="#000080" BGCOLOR="#FFC040" LINK="#0000FF" VLINK="#008000" ALINK="#00FFFF"',
    'black',    'TEXT="#FFFFFF" BGCOLOR="#000000" LINK="#FFFF00" VLINK="#C0C0C0" ALINK="#C0FFC0"',
    'green',    'TEXT="#FFFFFF" BGCOLOR="#004000" LINK="#FFFF00" VLINK="#80FF80" ALINK="#00FF40"',
    'blue',     'TEXT="#FFFFFF" BGCOLOR="#000080" LINK="#FFFF00" VLINK="#8080FF" ALINK="#FF00FF"',
    'violet',   'TEXT="#FFFFFF" BGCOLOR="#800080" LINK="#00FFFF" VLINK="#80FFFF" ALINK="#00FF00"',
    'plain',    'TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#666666" ALINK="#FF00FF"',

    'stplain',  'TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#0000CC" ALINK="#FF00FF"',
    'styellow', 'TEXT="#000000" BGCOLOR="#FFFFC0" LINK="#0000FF" VLINK="#000066" ALINK="#FF00FF"',
    'christmas','TEXT="#FFFFFF" BGCOLOR="#006600" LINK="#FF0000" VLINK="#990000" ALINK="#00FF40"',
);

#
%replacer_html = (
     '-[',     '<UL>',
     '-]',     '</UL>',
     '-(',     '<BLOCKQUOTE>',
     '-)',     '</BLOCKQUOTE>',
     '--(',    '<PRE>',
     '--)',    '</PRE>',
     '---(',   '<PRE><SAMP>',
     '---)',   '</SAMP></PRE>',
     '==(',    '<BLOCKQUOTE><PRE>',
     '==)',    '</PRE></BLOCKQUOTE>',
     '===(',   '<BLOCKQUOTE><PRE><SAMP>',
     '===)',   '</SAMP></PRE></BLOCKQUOTE>',
);

%replacer_latex = (
     '-[',      '\begin{itemize}',
     '-]',      '\end{itemize}',
     '-(',      '\begin{quotation}',
     '-)',      '\end{quotation}',
     '--(',     '\begin{verbatim}',
     '--)',     '\end{verbatim}',
     '---(',    '\begin{verbatim}',
     '---)',    '\end{verbatim}',
     '==(',     '\begin{verbatim}',
     '==)',     '\end{verbatim}',
     '===(',    '\begin{verbatim}',
     '===)',    '\end{verbatim}',
);

#
$newline = "\n";

# main
if (scalar(@ARGV) <= 1) {
    print $usage;
    exit(-1);
}
$given_mode = shift @ARGV;
if ($given_mode =~ /^-(.*)/) {
    $given_mode = $1;
} else {
    print $usage;
    exit(-1);
}
print "GIVEN_MODE: $given_mode\n" if ($debug);
if ($given_mode eq 'latex') {
    $latex = 1;
    *replacer = *replacer_latex;
} elsif ($given_mode eq 'html') {
    $html = 1;
    *replacer = *replacer_html;
} else {
    print $usage;
    exit(-1);
}
&init_defs();
foreach $file (@ARGV) {
    &do_file($file);
}
exit(0);

# error
sub error {
    local($msg) = shift;
    $errmsg = "$file:($lineno) ERROR:$msg:$line\n";
    die $errmsg;
}

#
sub normalize {
    local($string) = shift;
    if ($html) {
        $string =~ s/&/&amp;/g;
        $string =~ s/"/&quot;/g;
        $string =~ s/</&lt;/g;
        $string =~ s/>/&gt;/g;
    } else {
        # yet
        $string =~ s/%/\%/g;
        $string =~ s/{/\{/g;
        $string =~ s/}/\}/g;
        $string =~ s/_/\_/g;
        $string =~ s/^/\^/g;
    }
    return $string;
}

#
#yet:-include̒ł͎gȂ悤
sub do_contents {
    if ($latex) {
        print <<"EOD";
% contents
% yet:This must be 'short contents'
\maketitle
\tableofcontents
\newpage
EOD
        return;
    }
    local(*FILE);
    local($id) = 0;
    local($num) = '';
    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
    if ($defs{'usenumber'}) {
        print "<BLOCKQUOTE>";
    } else {
        print "<UL>";
    }
    foreach $line (<FILE>) {
        chop($line);
        if ($line =~ /^\*(.*)/ || $line =~ /^>\*(.*)/) {
            $id++;
            if ($defs{'usenumber'}) {
                print qq|<A HREF="#id$id">$id. $1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id">$1</A>|;
            }
        }
    }
    if ($defs{'usenumber'}) {
        print "</BLOCKQUOTE>";
    } else {
        print "</UL>";
    }
    close(FILE);
}

#
sub do_detailcontents {
    if ($latex) {
        print <<"EOD";
% detail contents
\\maketitle
\\tableofcontents
\\newpage
EOD
        return;
    }
    local(*FILE);
    local($id) = 0;
    local($did) = 0;
    local($subitem) = 0;
    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
    if ($defs{'usenumber'}) {
        $elem = 'BLOCKQUOTE';
    } else {
        $elem = 'UL';
    }
    print "<$elem>";
    foreach $line (<FILE>) {
        chop($line);
        if ($line =~ /^\*(.*)/ || $line =~ /^>\*(.*)/) {
            $id++;
            $did = 0;
            $num = "$id. " if ($defs{'usenumber'});
            print qq|</$elem>$newline| if ($insubitem);
            if ($defs{'usenumber'}) {
                print qq|<A HREF="#id$id">$num$1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id">$1</A>|;
            }
            $insubitem = 0;
        } elsif ($line =~ /^-\*(.*)/ || $line =~ /^>-\*(.*)/) {
            $did++;
            $num = "$id.$did. " if ($defs{'usenumber'});
            print qq|<$elem>$newline| unless ($insubitem);
            if ($defs{'usenumber'}) {
                print qq|<A HREF="#id$id| . qq|did$did">$num$1</A><BR>|;
            } else {
                print qq|<LI><A HREF="#id$id| . qq|did$did">$1</A>|;
            }
            $insubitem = 1;
        }
    }
    print qq|</$elem>| if ($insubitem);
    print "</$elem>";
    close(FILE);
}

# -define=
sub do_define {
    local($definename, $definecontent) = @_;
    $defs{$definename} = $definecontent;
}

# -include=
sub do_file {
    local($file) = shift;
    local(*FILE);
    local($id, $did, $insubitem) = (0, 0, 0);
    local($num) = '';

    print "<!-- $file -->$newline" if ($config{'include_filename'});

    open(FILE, $file) || die "MakeWeb: I cannot open $file.\n";
LINE:
    for ($lineno = 1; $line = <FILE>; $lineno++) {
        if ($line =~ /<-([a-zA-Z_0-9]+)>/) {
            $line =~ s/<-([a-zA-Z_0-9]+)>/$defs{$1}/gi;
            redo LINE;
        }
        chop($line);
        if ($line =~ /^;/) {
            next LINE;
        }
        # -if something
        if ($line =~ /^-if\s+(.*)/) {
            push(@mode_stack, $current_mode);
            $current_mode = $1;
            print "\nENTERING: $current_mode" if ($debug);
            next LINE;
        }
        # -endif
        if ($line =~ /^-endif\b/) {
            unless (@mode_stack) {
                &error("Missing '-if'");
            }
            print "\nLEAVING: $current_mode" if ($debug);
            $current_mode = pop(@mode_stack);
            next LINE;
        }
        # mode check
        if ($current_mode && $current_mode ne $given_mode) {
            print "\nSKIP: $line\n" if ($debug);
            next LINE;
        }
        if ($line =~ /^--\[/) {
            $horizontal = 1;
            print qq# | $newline#;
            next LINE;
        }
        if ($line =~ /^--\]/) {
            $horizontal = 0;
            print qq| $newline|;
            next LINE;
        }
        if ($tag = $replacer{$line}) {
            print "\nREPLACE:" if ($debug);
            print "$tag";
            print "$newline" unless ($tag =~ /<PRE>/i);   # <PRE>̂Ƃ͉sȂ
            if ($tag eq '\begin{verbatim}') {
                $verbatim = 1;
            } elsif ($tag eq '\end{verbatim}') {
                $verbatim = 0;
            }
            next LINE;
        }
        if ($line =~ /^>>(.*)/) {
            $linkcaption = $1;
            $href = $1;
            print "\nSELFLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($defs{'usetilde'});
            if ($html)  {
                print qq|<A HREF="$href">$linkcaption</A>$newline|;
            }
            if ($latex) {
                print qq|$linkcaption ($href)$newline|;
            }
            next LINE;
        }
        if ($line =~ /^>- (.*)/) {
            $linkcaption = $1;
            $lineno++;
            $line = <FILE>;
            chop($line);
            $href = $line;
            print "\nLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($defs{'usetilde'});
            if ($html)  {
                if ($horizontal) {
                    print qq#<A HREF="$href">$linkcaption</A> | $newline#;
                } else {
                    print qq|<LI><A HREF="$href">$linkcaption</A>$newline|;
                }
            }
            if ($latex) { print "\\item $linkcaption \\par\\noindent\\verb|$href|$newline"; }
            next LINE;
        }
        if ($line =~ /^>(.*)/) {
            $linkcaption = $1;
            $lineno++;
            $line = <FILE>;
            chop($line);
            $href = $line;
            print "\nLINK:" if ($debug);
            $href =~ s/~/%7E/g if ($defs{'usetilde'});
            if ($html)  { print qq|<A HREF="$href">$linkcaption</A>$newline|; }
            if ($latex) { print "$linkcaption (\\verb|$href|)$newline"; }
            next LINE;
        }
        if ($line =~ /^\*(.*)/) {
            print "\nBIGHEAD:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            if ($html)  {
                $id++;
                $did = 0;
                print qq|<A NAME="id$id"><BR></A>$newline|;
                $num = "$id. " if ($defs{'usenumber'});
                print "$defs{'itemline'}$newline<H2>$defs{'ball'}$num$s</H2>$newline";
            }
            if ($latex) {
                if ($defs{'usenumber'}) {
                    print "$newline\\section{$s}$newline";
                } else {
                    print "$newline\\section*{$s}$newline";
                }
            }
            $insubitem = 0;
            next LINE;
        }
        if ($line =~ /^-\*(.*)/) {
            print "\nSMALLHEAD:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            if ($html) {
                $did++;
                $num = "$id.$did. " if ($defs{'usenumber'});
                print qq|<A NAME="id$id| . qq|did$did"><BR></A>$newline|;
                print "$defs{'subitemline'}<H3>$num$s</H3>$newline";
            } elsif ($latex) {
                if ($defs{'usenumber'}) {
                    print "$newline\\subsection{$s}$newline";
                } else {
                    print "$newline\\subsection*{$s}$newline";
                }
            }
            $insubitem = 1;
            next LINE;
        }
        if ($line =~ /^- (.*)/) {
            print "\nLIST:" if ($debug);
            $s = $1;
            $s =~ s/^\s+//;
            $s =~ s/^\s+$//;
            if ($html) {
                print "<LI>$s$newline";
            } elsif ($latex) {
                print "\\item $s$newline";
            }
            next LINE;
        }
        if ($line =~ /^\|(.*)/) {
            print "\nVERBATIM:" if ($debug);
            $s = $1;
            if ($html) {
                print "$s$newline";
            } elsif ($latex) {
                print "$s$newline"; # \verb?
            }
            next LINE;
        }
        if ($line =~ /^!(.*)/) {
            print "\nEMPH:" if ($debug);
            $s = $1;
            if ($html) {
                print "<STRONG>$s</STRONG>$newline";
            } elsif ($latex) {
                print "{\\gt\\bf $s}$newline";
            }
            next LINE;
        }
        if ($line =~ /^=>(.*)/) {
            print "\nONELINEQUOTE:" if ($debug);
            $s = $1;
            if ($html) {
                print "<BLOCKQUOTE>$s</BLOCKQUOTE>$newline";
            } elsif ($latex) {
                print "$s$newline"; # yet
            }
            next LINE;
        }
        # Commands that begin with '-'.
        if ($line =~ /^-(.*)/) {
            # HTML only commands
            # -name command (HTML only)
            if ($line =~ /^-name=(.*)$/) {
                print "\nNAME:" if ($debug);
                if ($html) {
                    print qq|<A NAME="$1"><BR></A>$newline|;
                }
                next LINE;
            }
            # -color command (HTML only)
            if ($line =~ /^-color=(.*)/) {
                if ($html) {
                    unless ($colortag{$1}) {
                        &error("Unknown color name");
                    }
                    &do_define('color', $colortag{$1});
                }
                next LINE;
            }
            # -background command (HTML only)
            if ($line =~ /^-background=(.*)/) {
                if ($html) {
                    $defs{background} = qq|BACKGROUND="$1"|;
                    &do_define('background', $defs{color});
                }
                next LINE;
            }
            # -ball command (HTML only)
            if ($line =~ /^-ball=(.*)/) {
                if ($html) {
                    # Do not quote $1, because you may write with WIDTH or HEIGHT.
                    $defs{ball} = "<IMG SRC=$1>";
                    &do_define('ball', $defs{ball});
                }
                next LINE;
            }
            foreach $defname (keys %defs) {
                if ($line =~ /^-$defname=(.*)/) {
                    $definecontent = $1;
                    &do_define($defname, $definecontent);
                    next LINE;
                } elsif ($line =~ /^-$defname$/) {
                    print "$defs{$defname}$newline";
                    next LINE;
                }
            }
            if ($line =~ /^-include=(.*)/) {
                print "\nFILE:$1" if ($debug);
                &do_file($1);
                next LINE;
            }
            if ($line =~ /^-define=(.*)/) {
                $definename = $1;
                $lineno++;
                $line = <FILE>;
                chop($line);
                &do_define($definename, $line);
                print qq|\nDEFINE:"$definename" -> "$line"| if ($debug);
                next LINE;
            }
            if ($line =~ /^-contents/) {
                print "\nCONTENTS:$1" if ($debug);
                &do_contents;
                next LINE;
            }
            if ($line =~ /^-detailcontents/) {
                print "\nDETAILCONTENTS:$1" if ($debug);
                &do_detailcontents;
                next LINE;
            }
            if ($line =~ /^-newline=(.*)/) {
                $onoff = $1;
                if ($onoff =~ /^off/) {
                    print "\nNEWLINE:off\n" if ($debug);
                    $newline = "";
                } else {
                    print "\nNEWLINE:on\n" if ($debug);
                    $newline = "\n";
                }
                next LINE;
            }
            if ($line =~ /^-\|(.*)/) {
                $s = &normalize($1);
                print "$s$newline";
                next LINE;
            }
        }
        if ($line =~ /^\+(.*)/) {
            print qq|<UL><LI>$1</UL>$newline|;
            next LINE;
        }
        if ($line =~ /^\$(.*)/) {
            if ($html)  { print qq|<DIV ALIGN="right">$1</DIV>$newline|; }
            if ($latex) { print qq|$1$newline|; }
            next LINE;
        }
        if ($line =~ /^\s*$/) {
            # Empty line.
            print "$defs{autoinsert}$newline";
            next LINE;
        }
        print "$line$newline";
    }
    close(FILE);
}
